// implementation of declaration

// functions initialize the parameters
// this continues when they failed too

// some buses of I2C are more slow than others
// bus should not be used much because of this
// else it busies the computer and the monitor

// bus of I2C should not be used while monitor is busy
// else monitor may not respond, even it may cancel or pause its business
// because of this, wait should be done after bus was used, at every time
// (callees do this, callers do not need)

#include <sdkddkver.h>
#include <afxwin.h>
#include <highlevelmonitorconfigurationapi.h>
#include <lowlevelmonitorconfigurationapi.h>
#include "communer.h"

// codes of MCCS (few in high-level-functions)
#define code_brightness     (0x10)
#define code_contrast       (0x12)
#define code_sharpness      (0x87)
#define code_red            (0x16)
#define code_green          (0x18)
#define code_blue           (0x1A)
#define code_reset          (0x04)
#define code_reset_geometry (0x06)
#define code_save           (0xB0)

// it provides duration to function that has it
// operating system is doing the most of the standard
// but this does all of them with additional duration
class waiter
{
private:
unsigned long m_duration;
unsigned long m_time;

public:

waiter(unsigned long duration)
{
    m_duration = duration;
    m_time = GetTickCount();
}

~waiter()
{
    m_time = GetTickCount() - m_time;
    if (m_time < m_duration) Sleep(m_duration - m_time);
}

};

BOOL get_name(CString & string)
{
DISPLAYCONFIG_PATH_INFO path[10];
DISPLAYCONFIG_MODE_INFO mode[10];
DISPLAYCONFIG_TARGET_DEVICE_NAME device;
unsigned int number_of_path = sizeof(path) / sizeof(path[0]);
unsigned int number_of_mode = sizeof(mode) / sizeof(mode[0]);
long status;

    string = "";

    ZeroMemory(&path,sizeof(path));
    ZeroMemory(&mode,sizeof(mode));
    status = QueryDisplayConfig(QDC_ONLY_ACTIVE_PATHS,&number_of_path,&path[0],&number_of_mode,&mode[0],NULL);
    if (status) return FALSE;

    ZeroMemory(&device,sizeof(device));
    device.header.size = sizeof(device);
    device.header.type = DISPLAYCONFIG_DEVICE_INFO_GET_TARGET_NAME;
    device.header.adapterId = path[0].targetInfo.adapterId;
    device.header.id = path[0].targetInfo.id;
    status = DisplayConfigGetDeviceInfo(&device.header);
    if (status) return FALSE;

    string = device.monitorFriendlyDeviceName;
    return TRUE;
}

BOOL get_brightness(unsigned long & current, unsigned long & maximum)
{
waiter wait(40+60);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    current = maximum = 0;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = GetVCPFeatureAndVCPFeatureReply(device.hPhysicalMonitor,code_brightness,NULL,&current,&maximum);
    if (status == FALSE) {current = maximum = 0;}

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL get_contrast(unsigned long & current, unsigned long & maximum)
{
waiter wait(40+60);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    current = maximum = 0;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = GetVCPFeatureAndVCPFeatureReply(device.hPhysicalMonitor,code_contrast,NULL,&current,&maximum);
    if (status == FALSE) {current = maximum = 0;}

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL get_sharpness(unsigned long & current, unsigned long & maximum)
{
waiter wait(40+60);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    current = maximum = 0;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = GetVCPFeatureAndVCPFeatureReply(device.hPhysicalMonitor,code_sharpness,NULL,&current,&maximum);
    if (status == FALSE) {current = maximum = 0;}

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL get_red(unsigned long & current, unsigned long & maximum)
{
waiter wait(40+60);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    current = maximum = 0;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = GetVCPFeatureAndVCPFeatureReply(device.hPhysicalMonitor,code_red,NULL,&current,&maximum);
    if (status == FALSE) {current = maximum = 0;}

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL get_green(unsigned long & current, unsigned long & maximum)
{
waiter wait(40+60);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    current = maximum = 0;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = GetVCPFeatureAndVCPFeatureReply(device.hPhysicalMonitor,code_green,NULL,&current,&maximum);
    if (status == FALSE) {current = maximum = 0;}

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL get_blue(unsigned long & current, unsigned long & maximum)
{
waiter wait(40+60);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    current = maximum = 0;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = GetVCPFeatureAndVCPFeatureReply(device.hPhysicalMonitor,code_blue,NULL,&current,&maximum);
    if (status == FALSE) {current = maximum = 0;}

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL set_brightness(unsigned long number)
{
waiter wait(50+70);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = SetVCPFeature(device.hPhysicalMonitor,code_brightness,number);

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL set_contrast(unsigned long number)
{
waiter wait(50+70);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = SetVCPFeature(device.hPhysicalMonitor,code_contrast,number);

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL set_sharpness(unsigned long number)
{
waiter wait(50+70);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = SetVCPFeature(device.hPhysicalMonitor,code_sharpness,number);

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL set_red(unsigned long number)
{
waiter wait(50+70);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = SetVCPFeature(device.hPhysicalMonitor,code_red,number);

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL set_green(unsigned long number)
{
waiter wait(50+70);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = SetVCPFeature(device.hPhysicalMonitor,code_green,number);

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL set_blue(unsigned long number)
{
waiter wait(50+70);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = SetVCPFeature(device.hPhysicalMonitor,code_blue,number);

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL reset_all()
{
waiter wait(5000+1000);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = SetVCPFeature(device.hPhysicalMonitor,code_reset,1);

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL reset_geometry()
{
waiter wait(5000+1000);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = SetVCPFeature(device.hPhysicalMonitor,code_reset_geometry,1);

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL save_mccs()
{
waiter wait(200+1000);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = SetVCPFeature(device.hPhysicalMonitor,code_save,1);

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}

BOOL save_ddcci()
{
waiter wait(200+1000);
HMONITOR monitor;
PHYSICAL_MONITOR device;
BOOL status;

    monitor = MonitorFromWindow(NULL,MONITOR_DEFAULTTOPRIMARY);
    if (monitor == NULL) return FALSE;

    status = GetPhysicalMonitorsFromHMONITOR(monitor,1,&device);
    if (status == FALSE) return FALSE;

    status = SaveCurrentSettings(device.hPhysicalMonitor); // code of DDC/CI is 0C

    DestroyPhysicalMonitor(device.hPhysicalMonitor);
    return status;
}
