// implementation of declaration

// SetPos must be used when SetRange was used
// SetRangeMin and SetRangeMax are not possible
// some things have not handled such send of message
// some things have not implemented such SetSelection
// slider is enabled and disabled when they are needed

#include <sdkddkver.h>
#include <afxwin.h>
#include <afxcmn.h>
#include "slider.h"

IMPLEMENT_DYNAMIC(slider, CSliderCtrl)

BEGIN_MESSAGE_MAP(slider, CSliderCtrl)
END_MESSAGE_MAP()

slider::slider()
{
    m_minimum = 0;
    m_maximum = 0;
}

slider::~slider()
{
}

// it is called automatically
void slider::PreSubclassWindow()
{
int minimum, maximum, position;

    CSliderCtrl::PreSubclassWindow();

    // learn default
    minimum  = CSliderCtrl::GetRangeMin();
    maximum  = CSliderCtrl::GetRangeMax();
    position = CSliderCtrl::GetPos();

    // initialize
    SetRange(minimum,maximum);
    SetPos(position);
}

void slider::SetRange(int minimum, int maximum)
{
    m_minimum = minimum;
    m_maximum = maximum;

    if (minimum == maximum)
    {
     CSliderCtrl::SetRange(0,1); // provide thumb at bottom
     CSliderCtrl::EnableWindow(FALSE); // prevent pseudo scroll
    }
    else
    {
     CSliderCtrl::SetRange(minimum,maximum); // normal status
     CSliderCtrl::EnableWindow(TRUE); // provide scroll
    }
}

void slider::SetRangeMin(int minimum)
{
    // not possible
    UNREFERENCED_PARAMETER(minimum);
    AfxAbort();
}

void slider::SetRangeMax(int maximum)
{
    // not possible
    UNREFERENCED_PARAMETER(maximum);
    AfxAbort();
}

void slider::GetRange(int & minimum, int & maximum)
{
    // because of pseudo
    minimum = m_minimum;
    maximum = m_maximum;
}

int slider::GetRangeMin()
{
    // because of pseudo
    return m_minimum;
}

int slider::GetRangeMax()
{
    // because of pseudo
    return m_maximum;
}

void slider::SetPos(int position)
{
    if (m_minimum == m_maximum)
    {
     // thumb at bottom (range was provided before)
     CSliderCtrl::SetPos(1);
    }
    else
    {
     // reverse position
     CSliderCtrl::SetPos(m_maximum - position + m_minimum);
    }
}

int slider::GetPos()
{
    if (m_minimum == m_maximum)
    {
     // because of pseudo
     return m_minimum;
    }
    else
    {
     // reverse position
     return m_maximum - CSliderCtrl::GetPos() + m_minimum;
    }
}
